/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_GL_UPDATERGLCOREVISITOR_H
#define X3DTK_GL_UPDATERGLCOREVISITOR_H

#include "GL_CoreVisitor.h"
#include "GL_UpdaterStateVariables.h"

namespace X3DTK {
namespace GL {

class Scene;

/*! \brief Class declared in <b><X3DTK/GL/updater.h></b> providing a visitor of the 
 *  Core component of the GL::Updater processor.
 *
 *  \ingroup GL
 */

class UpdaterCoreVisitor : public CoreVisitor
{
public:
  /// Constructor.
  UpdaterCoreVisitor();

  /// Enters a Scene.
  static void enterScene(Scene *S);
  /// Enters a X3DNode.
  static void enterX3DNode(X3DNode *N);
};

}
}

#endif
