/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_PROGRESS_H
#define X3DTK_PROGRESS_H

#include "Platform.h"
#include "Signal.h"

namespace X3DTK {

/*! \brief Class declared in <b><X3DTK/kernel.h></b> defining a Progress class that 
 *  manages the progress of a processor.
 *
 *  \ingroup processor
 */
 
class Progress
{
public:
  /// Constructor.
  Progress(int step = 1);

  /// Sets the number of total steps.
  void setTotalSteps(int totalSteps);
  /// Sets the progress.
  void setProgress(int progress);

  /// Gets the number of total steps.
  int getTotalSteps() const;
  /// Gets the progress.
  int getProgress() const;

private:  
  int _totalSteps;
  int _progress;
  int _step;
  int _inc;
};

}

#endif
